%assign CX_COUNT 32
;; LD_CX_COUNT = ld(2*CX_COUNT)  ld(x)=base-2 logarithm of x
%assign LD_CX_COUNT 6

%define lines [ebp+8]
global  correlation

extern correl_lines,couple_index,couple_index_nb

segment	.text
	align 16
correlation:
	push	ebp
	mov	ebp,esp
	sub	esp,4
	push	edi
	push	esi
	push	ebx

	mov	dword [ebp-4],correl_lines
	
	movq	mm5,[one]
	xor	ebx,ebx
        
	align 16
M2:	mov	eax,[couple_index+ebx*4]	; v=couple_index[i]
	mov	edx,eax
	shr	eax,9			; y1=v >> 9
	shl	eax,LD_CX_COUNT		; ld (CX_COUNT*2)
	mov	esi,lines
	mov	edi,esi
	add	esi,eax
	
	and	edx,0x1ff		; y2=v & 0x1ff
	shl	edx,LD_CX_COUNT		; ld (CX_COUNT*2)
	add	edi,edx

	pandn	mm3,mm3			; mm3=s=0
%assign i 0
%rep CX_COUNT/4 
	movq	mm0,[esi+i*8]
	movq	mm1,[edi+i*8]
	pandn	mm6,mm6			; mm6=0
	psubw	mm0,mm1
	movq	mm2,mm0
	pcmpgtw	mm6,mm0		; if (word < 0) word=0xffff else word=0x0000
	psubw	mm0,mm5		; -1
	pandn	mm0,mm6		; negate
	paddw	mm3,mm0		; s+=word (<0)
	pandn	mm6,mm2
	paddw	mm3,mm6		; s+=word (>=0)
%assign i i+1
%endrep
	movq	mm4,mm3
	psrlq	mm3,32
	paddw	mm3,mm4		; w0 + w2 , w1 + w3 -> mm3
	movq	mm4,mm3
	psrlq	mm4,16
	paddw	mm3,mm4
	movd	eax,mm3		; eax = s
	and	eax,0xffff
	mov	ecx,[ebp-4]
	mov	[ecx],eax
	add	dword [ebp-4],4

	inc	ebx
	cmp	ebx,[couple_index_nb]
	jne	near M2

	emms
	pop	ebx
	pop	esi
	pop	edi
	mov	esp,ebp
	pop	ebp
	ret
	
one	dd	0x00010001,0x00010001
