%assign SKIP 10
%assign STEP 8
%assign X_INC 2
	

%define	baseline [ebp+8]
%define	line [ebp+12]
%define	ls [ebp-4]
%define	best_shift [ebp-8]
%define	bs [ebp-12]

segment .text

global findShift_small, findShift_full
	
%macro	corr_line 0
%%l1:	movq	mm0,[esi+ecx]		; bi -> mm0
	movq	mm1,[edi+ecx]		; li -> mm1
	psubw	mm0,mm1			; bi-li
	pmaddwd	mm0,mm0			; (bi-li)*(bi-li)
	add	ecx,X_INC*8
	paddd	mm2,mm0
	cmp	ecx,ebx
	jl	%%l1
%endmacro

%macro	correlation 2
	mov	esi,tmpbline
%%k1:	xor	ecx,ecx
	psllq	mm2,64			; mm2 = s = 0
	lea	edi,[tmpline+edx*2]
	
	corr_line
	
	movq	mm3,mm2
	psrlq	mm3,32
	paddd	mm3,mm2
	movd	eax,mm3
	cmp	eax,ls
	jae	%%m1
	mov	best_shift,edx
	mov	ls,eax

%%m1:	add	edx,%2
	cmp	edx,%1
	jb	%%k1
%endmacro
	
findShift_small:
	push ebp 
	mov ebp,esp
	sub sp,12
	push ebx
	push ecx
	push edx
	push esi
	push edi

	mov	eax,baseline
	lea	esi,[eax+2*SKIP-4]
	mov	edi,tmpbline-4
	mov	ecx,(384-SKIP)/2
.s1	mov	eax,[esi+ecx*4]
	and	eax,0x00ff00ff
	mov	[edi+ecx*4],eax
	loop	.s1

	mov	eax,line
	lea	esi,[eax+2*SKIP-4]
	mov	edi,tmpline-4
	mov	ecx,(384-SKIP)/2
.s2	mov	eax,[esi+ecx*4]
	and	eax,0x00ff00ff
	mov	[edi+ecx*4],eax
	mov	[edi+ecx*4+2*(384-SKIP)],eax
	loop	.s2

	mov	dword ls,0xffffffff	; ls=0xffffffff
	mov	dword best_shift,0
	xor	edx,edx			; k = 0 = edx
	mov	ebx,(384-SKIP)*2
	
	correlation (384-SKIP),STEP

	mov	edx,best_shift
	cmp	edx,STEP		; if (bs<step)
	jae	.m2
	mov	edx,STEP		; bs=STEP
.m2	cmp	edx,384-SKIP-STEP	; if (bs>384-SKIP-STEP)
	jbe	.m3
	mov	edx,384-SKIP-STEP	; bs=384-SKIP-STEP

.m3	mov	dword best_shift,0	; best_shift=0
	mov	dword ls,0xffffffff	; ls=0xffffffff
	mov	eax,edx
	sub	edx,STEP		; k=bs-step 
	mov	ebx,(384-SKIP)*2
	add	eax,STEP
	mov	bs,eax

	correlation bs,1

	mov	eax,best_shift
			
	emms
	pop edi
	pop esi
	pop edx
	pop ecx
	pop ebx
	leave
	ret

findShift_full:
	push ebp 
	mov ebp,esp
	sub sp,12
	push ebx
	push ecx
	push edx
	push esi
	push edi

	mov	eax,baseline
	lea	esi,[eax+4*SKIP-4]
	mov	edi,tmpbline-4
	mov	ecx,(384-SKIP)
.s3	mov	eax,[esi+ecx*4]
	and	eax,0x00ff00ff
	mov	[edi+ecx*4],eax
	loop	.s3

	mov	eax,line
	lea	esi,[eax+4*SKIP-4]
	mov	edi,tmpline-4
	mov	ecx,(384-SKIP)
.s4	mov	eax,[esi+ecx*4]
	and	eax,0x00ff00ff
	mov	[edi+ecx*4],eax
	mov	[edi+ecx*4+4*(384-SKIP)],eax
	loop	.s4

	mov	dword ls,0xffffffff	; ls=0xffffffff
	mov	dword best_shift,0
	xor	edx,edx			; k = 0 = edx
	mov	ebx,(384-SKIP)*4
	
	correlation (384-SKIP)*2,STEP

	mov	edx,best_shift
	cmp	edx,STEP		; if (bs<step)
	jae	.m2
	mov	edx,STEP		; bs=STEP
.m2	cmp	edx,(384-SKIP)*2-STEP	; if (bs>(384-SKIP)*2-STEP)
	jbe	.m3
	mov	edx,(384-SKIP)*2-STEP	; bs=(384-SKIP)*2-STEP

.m3	mov	dword best_shift,0	; best_shift=0
	mov	dword ls,0xffffffff	; ls=0xffffffff
	mov	eax,edx
	sub	edx,STEP		; k=bs-step 
	mov	ebx,(384-SKIP)*4
	add	eax,STEP
	mov	bs,eax

	correlation bs,1

	mov	eax,best_shift
			
	emms
	pop edi
	pop esi
	pop edx
	pop ecx
	pop ebx
	leave
	ret

segment .bss
tmpline	resb 1536*2
tmpbline resb 1536*2
